Summary
This is a pretty easy problem, but one may get confused by the term "inplace" and think it is impossible to remove an element from the array without making a copy of the array.
Hints
 Try two pointers.
 Did you use the fact that the order of elements can be changed?
 What happens when the elements to remove are rare?
Solution
Approach 1: Two Pointers
Intuition
Since this question is asking us to remove all elements of the given value inplace, we have to handle it with extra space. How to solve it? We can keep two pointers and , where is the slowrunner while is the fastrunner.
Algorithm
When equals to the given value, skip this element by incrementing . As long as , we copy to and increment both indexes at the same time. Repeat the process until reaches the end of the array and the new length is .
This solution is very similar to the solution to Remove Duplicates from Sorted Array.
Complexity analysis

Time complexity : . Assume the array has a total of elements, both and traverse at most steps.

Space complexity : .
Approach 2: Two Pointers  when elements to remove are rare
Intuition
Now consider cases where the array contains few elements to remove. For example, . The previous algorithm will do unnecessary copy operation of the first four elements. Another example is . It seems unnecessary to move elements one step left as the problem description mentions that the order of elements could be changed.
Algorithm
When we encounter , we can swap the current element out with the last element and dispose the last one. This essentially reduces the array's size by 1.
Note that the last element that was swapped in could be the value you want to remove itself. But don't worry, in the next iteration we will still check this element.
Complexity analysis

Time complexity : . Both and traverse at most steps. In this approach, the number of assignment operations is equal to the number of elements to remove. So it is more efficient if elements to remove are rare.

Space complexity : .